﻿module("VOICE")

----------------------------------------------------------------------------------------------------
---------------------------|  V O I C E   T R A N S F O R M   U T I L S  |--------------------------
----------------------------------------------------------------------------------------------------

-----------------------------------------------
-- ASSERT a konyvtari transform fuggvenyekre --
-----------------------------------------------
function set_tts_settings()
	if MODEL.EXISTS.lua.tts.numbers_mode() then numbers_mode = MODEL.lua["tts.numbers_mode"]()
	else numbers_mode = SysConfig:get("tts", "numbers_mode", 1) end
	set_distances_meters()
	set_distances_ttspro_meters()
	local unit_names = {"yards","meters","feet"}
	dist_table = distances[unit_names[MODEL.regional.units() + 1]]
	if MODEL.EXISTS.lua.tts.sentence_variations() then sentence_variations = MODEL.lua["tts.sentence_variations"]()
	else sentence_variations = SysConfig:get("tts", "sentence_variations", 1) end
	set_pattern_variations()
	if MODEL.EXISTS.lua.tts.roadnumber_mode() then roadnumber_mode = MODEL.lua["tts.roadnumber_mode"]()
	else roadnumber_mode = SysConfig:get("tts", "roadnumber_mode", 1) end
	if MODEL.EXISTS.lua.tts.traffic_events_description() then traffic_events_description = MODEL.lua["tts.traffic_events_description"]()
	else traffic_events_description = SysConfig:get("tts", "traffic_events_description", 1) end
	if MODEL.EXISTS.lua.tts.traffic_events_distance() then traffic_events_distance = MODEL.lua["tts.traffic_events_distance"]()
	else traffic_events_distance = SysConfig:get("tts", "traffic_events_distance", 0) end
end
set_tts_settings()

assert(type(transform_and_format) == "function")
assert(type(transform_pattern_match) == "function")
assert(type(transform_chain) == "function")
assert(type(transform_format_roadnumber_eu) == "function")

local preposition_tbl = {L"Через",L"в Направлении На"}

local preposition_insert_tbl = {
	{L"в ",{L"Переулок",L"Проезд",L"Тупик"}},
	{L"на ",{L""}},
}

local main_streetname = L"Улица"
local mother_country = "_rus"
local settlement_preposition = L"в направлении на"
local exit_preposition = L"на съезд"
local replace_roadnumber_prepare = {
	{L"^ ",L""},
	{wstring.char(160),L""},
	{L"[еЕ]",L"E"},
	{L"[мМ]",L"M"},
	{L"[nHН]",L"N"},
	{L"[рPР]",L"R"},
	{L"[tтТ]",L"T"},
	{L"[аА]",L"A"},
}
VOICE["replace_roadnumber" .. mother_country] = {
	{L"(.*)",L"%1/"},
	{L"^A +100(%D)",L"Дорога Москва Бородино%1"},
	{L"^A +101(%D)",L"Дорога Москва Рославль%1"},
	{L"^A +102(%D)",L"Рязанское Шоссе%1"},
	{L"^A +103(%D)",L"Щелковское Шоссе%1"},
	{L"^A +104(%D)",L"Дмитровское Шоссе%1"},
	{L"^A +105(%D)",L"Успенское Шоссе%1"},
	{L"^A +106(%D)",L"Ильинское Шоссе%1"},
	{L"^A +107(%D)",L"Московское малое кольцо%1"},
	{L"^A +108(%D)",L"Московское большое кольцо%1"},
	{L"^A +111(%D)",L"Дорога Торжок Осташков%1"},
	{L"^A +112(%D)",L"Дорога Тверь Ржев%1"},
	{L"^A +113(%D)",L"Дорога Кострома Иваново%1"},
	{L"^A +114(%D)",L"Дорога Вологда Новая Ладога%1"},
	{L"^A +116(%D)",L"Дорога Порхов Остров%1"},
	{L"^A +117(%D)",L"Дорога Опочка граница с Белоруссией%1"},
	{L"^A +121(%D)",L"Дорога Санкт-Петербург Ропша%1"},
	{L"^A +122(%D)",L"Дорога Санкт-Петербург Огоньки%1"},
	{L"^A +123(%D)",L"Дорога Зеленогорск Выборг%1"},
	{L"^A +124(%D)",L"Дорога Выборг Приозерск%1"},
	{L"^A +125(%D)",L"Дорога Молодежное Черкасово%1"},
	{L"^A +126(%D)",L"Дорога Дубки граница с Финляндией%1"},
	{L"^A +127(%D)",L"Дорога Зверево граница с Финляндией%1"},
	{L"^A +128(%D)",L"Дорога Санкт-Петербург Морье%1"},
	{L"^A +129(%D)",L"Дорога Зеленогорск Выборг%1"},
	{L"^A +130(%D)",L"Дорога Олонец Сортавала%1"},
	{L"^A +131(%D)",L"Дорога Суоярви Койриноя%1"},
	{L"^A +132(%D)",L"Дорога Суоярви Юстозеро%1"},
	{L"^A +133(%D)",L"Дорога Петрозаводск Суоярви%1"},
	{L"^A +134(%D)",L"Дорога Кочкома Реболы%1"},
	{L"^A +135(%D)",L"Дорога Кемь Лонка%1"},
	{L"^A +136(%D)",L"Дорога Лоухи Суоперя%1"},
	{L"^A +137(%D)",L"Дорога Тунгозеро Калевала%1"},
	{L"^A +138(%D)",L"Дорога Кола Печенга%1"},
	{L"^A +141(%D)",L"Дорога Орел Смоленск%1"},
	{L"^A +142(%D)",L"Дорога Тросна Калиновка%1"},
	{L"^A +144(%D)",L"Дорога Курск Борисоглебск%1"},
	{L"^A +146(%D)",L"Дорога Краснодар Новоросийск%1"},
	{L"^A +147(%D)",L"Дорога Краснодар Джубга%1"},
	{L"^A +148(%D)",L"Дорога Адлер Красная Поляна%1"},
	{L"^A +151(%D)",L"Дорога Цивильск Ульяновск%1"},
	{L"^A +153(%D)",L"Дорога Волгоград Мариновка%1"},
	{L"^A +154(%D)",L"Дорога Астрахань Ставрополь%1"},
	{L"^A +155(%D)",L"Дорога Черкесск Домбай%1"},
	{L"^A +156(%D)",L"Дорога Лермонтов Черкесск%1"},
	{L"^A +157(%D)",L"Дорога Минеральные Воды Кисловодск%1"},
	{L"^A +158(%D)",L"Дорога Прохладный Баксан Эльбрус%1"},
	{L"^A +166(%D)",L"Дорога Чита Забайкальск%1"},
	{L"^A +190(%D)",L"Дорога Калининград Полесск%1"},
	{L"^A +191(%D)",L"Дорога Калининград Зеленоградск%1"},
	{L"^A +192(%D)",L"Дорога Зеленоградск Приморск%1"},
	{L"^A +193(%D)",L"Дорога Калининград Балтийск%1"},
	{L"^A +194(%D)",L"Дорога Калининград Мамоново%1"},
	{L"^A +195(%D)",L"Дорога Калининград Долгоруково%1"},
	{L"^A +196(%D)",L"Дорога Калининград Крылово%1"},
	{L"^A +197(%D)",L"Дорога Черняховск Крылово%1"},
	{L"^A +198(%D)",L"Дорога Советск Гусев%1"},
	{L"^A +212(%D)",L"Дорога Псков Изборск%1"},
	{L"^A +216(%D)",L"Дорога Гвардейск Неман%1"},
	{L"^A +229(%D)",L"Дорога Калининград Нестеров%1"},
	{L"^A +340(%D)",L"Дорога Астрахань Красный Яр%1"},
	{L"^A +349(%D)",L"Дорога Барнаул Рубцовск%1"},
	{L"^E +18(%D)",L"Трасса Выборг Санкт-Петербург%1"},
	{L"^E +20(%D)",L"Трасса Таллин Санкт-Петербург%1"},
	{L"^E +22(%D)",L"Трасса Рига Москва Тюмень%1"},
	{L"^E +28(%D)",L"Трасса Калининград Нестеров%1"},
	{L"^E +30(%D)",L"Трасса Минск Москва Омск%1"},
	{L"^E +38(%D)",L"Трасса Глухов Воронеж Уральск%1"},
	{L"^E +40(%D)",L"Трасса Харьков Волгоград Астрахань%1"},
	{L"^E +50(%D)",L"Трасса Донецк Ростов-на-Дону Махачкала%1"},
	{L"^E +58(%D)",L"Трасса Мариуполь Ростов-на-Дону%1"},
	{L"^E +77(%D)",L"Трасса Псков Рига Калининград%1"},
	{L"^E +95(%D)",L"Трасса Санкт-Петербург Витебск%1"},
	{L"^E +97(%D)",L"Трасса Новороссийск Сочи%1"},
	{L"^E +101(%D)",L"Трасса Москва Брянск Киев%1"},
	{L"^E +105(%D)",L"Трасса Мурманск Белгород%1"},
	{L"^E +115(%D)",L"Трасса Ярославль Москва Новороссийск%1"},
	{L"^E +117(%D)",L"Трасса Минеральные Воды Нальчик Владикавказ%1"},
	{L"^E +119(%D)",L"Трасса Махачкала Баку%1"},
	{L"^M +0?1(%D)",L"Трасса Москва Минск%1"},
	{L"^M +0?2(%D)",L"Трасса Москва Симферополь%1"},
	{L"^M +0?3(%D)",L"Трасса Москва Киев%1"},
	{L"^M +0?4(%D)",L"Трасса Москва Новороссийск%1"},
	{L"^M +0?5(%D)",L"Трасса Москва Екатеринбург%1"},
	{L"^M +0?6(%D)",L"Трасса Москва Астрахань%1"},
	{L"^M +0?7(%D)",L"Трасса Москва Уфа%1"},
	{L"^M +0?8(%D)",L"Трасса Москва Архангельск%1"},
	{L"^M +0?9(%D)",L"Трасса Москва Рига%1"},
	{L"^M +10(%D)",L"Трасса Москва Санкт-Петербург%1"},
	{L"^M +11(%D)",L"Трасса Санкт-Петербург Таллин%1"},
	{L"^M +12(%D)",L"Трасса Минск Вильнюс Рига Таллин%1"},
	{L"^M +13(%D)",L"Трасса Брянск Новозыбков%1"},
	{L"^M +14(%D)",L"Трасса Брест Кишинев Одесса%1"},
	{L"^M +17(%D)",L"Трасса Киев Чоп Будапешт%1"},
	{L"^M +18(%D)",L"Трасса Санкт-Петербург Мурманск%1"},
	{L"^M +19(%D)",L"Трасса Новошахтинск Майский%1"},
	{L"^M +20(%D)",L"Трасса Санкт-Петербург Минск%1"},
	{L"^M +21(%D)",L"Трасса Волгоград Каменск Шахтинский%1"},
	{L"^M +23(%D)",L"Трасса Ростов-на-Дону Таганрог%1"},
	{L"^M +25(%D)",L"Трасса Новороссийск Керченский пролив%1"},
	{L"^M +27(%D)",L"Трасса Джубга Новороссийск%1"},
	{L"^M +29(%D)",L"Трасса Краснодар Баку%1"},
	{L"^M +32(%D)",L"Трасса Самара Большая Черниговка%1"},
	{L"^M +36(%D)",L"Трасса Челябинск Троицк%1"},
	{L"^M +38(%D)",L"Трасса Омск Черлак%1"},
	{L"^M +51(%D)",L"Трасса Челябинск Чита%1"},
	{L"^M +52(%D)",L"Трасса Новосибирск Бийск%1"},
	{L"^M +53(%D)",L"Трасса Челябинск Чита%1"},
	{L"^M +54(%D)",L"Трасса Красноярск Кызыл%1"},
	{L"^M +55(%D)",L"Трасса Челябинск Чита%1"},
	{L"^M +56(%D)",L"Трасса Невр Якутск%1"},
	{L"^M +60(%D)",L"Трасса Хабаровск Владивосток%1"},
	{L"^R +0?1(%D)",L"Дорога Архангельск Прокшино%1"},
	{L"^R +0?2(%D)",L"Дорога М8 Няндома Пудож%1"},
	{L"^R +0?5(%D)",L"Дорога Вологда Медвежьегорск%1"},
	{L"^R +0?6(%D)",L"Дорога Череповец Липин Бор%1"},
	{L"^R +0?7(%D)",L"Дорога Чекшино Никольск%1"},
	{L"^R +0?8(%D)",L"Дорога Устюжна Валдай%1"},
	{L"^R +10(%D)",L"Дорога Лиинахамари граница Финляндии Виртаниеми%1"},
	{L"^R +12(%D)",L"Дорога Мурманск КПП Лотта%1"},
	{L"^R +15(%D)",L"Дорога Петрозаводск Гирвас%1"},
	{L"^R +16(%D)",L"Дорога Пудож Семеново%1"},
	{L"^R +17(%D)",L"Дорога Медвежьегорск Великая Губа%1"},
	{L"^R +18(%D)",L"Дорога Пушной Беломорск%1"},
	{L"^R +19(%D)",L"Дорога Петрозаводск Оштинский Погост%1"},
	{L"^R +20(%D)",L"Дорога Спасская Губа Корписелькя%1"},
	{L"^R +21(%D)",L"Дорога Пряжа Колатсельга Леметти%1"},
	{L"^R +25(%D)",L"Дорога Сыктывкар Вогваздино Ухта%1"},
	{L"^R +26(%D)",L"Дорога Сыктывкар Троицко-Печорск%1"},
	{L"^R +27(%D)",L"Дорога Вогваздино Яренск%1"},
	{L"^R +28(%D)",L"Дорога Айкино Кослан%1"},
	{L"^R +33(%D)",L"Дорога Санкт-Петербург Запорожское%1"},
	{L"^R +34(%D)",L"Дорога Ушково Гравийное%1"},
	{L"^R +35(%D)",L"Дорога Петродворец Кейкино%1"},
	{L"^R +36(%D)",L"Дорога Ладейное Поле Чудово%1"},
	{L"^R +37(%D)",L"Дорога Лодейное Поле Вытегра%1"},
	{L"^R +38(%D)",L"Дорога Гатчина Ополье%1"},
	{L"^R +39(%D)",L"Дорога Пружицы Толмачево%1"},
	{L"^R +40(%D)",L"Дорога Кемполово Тосно Шапки%1"},
	{L"^R +41(%D)",L"Дорога Павлово Любань Луга%1"},
	{L"^R +42(%D)",L"Дорога Гостицы Косколково%1"},
	{L"^R +47(%D)",L"Дорога Новгород Луга%1"},
	{L"^R +48(%D)",L"Дорога Яжелбицы Старая Русса Сольцы%1"},
	{L"^R +49(%D)",L"Дорога Красея Лычково%1"},
	{L"^R +50(%D)",L"Дорога Демянск Марево%1"},
	{L"^R +51(%D)",L"Дорога Шимск Великие Луки Невель%1"},
	{L"^R +52(%D)",L"Дорога Шимск Николаево%1"},
	{L"^R +53(%D)",L"Дорога Спасская Полисть Боровичи%1"},
	{L"^R +56(%D)",L"Дорога Новгород Порхов Псков%1"},
	{L"^R +57(%D)",L"Дорога Порхов Успенское%1"},
	{L"^R +58(%D)",L"Дорога Локня Пушкинские Горы%1"},
	{L"^R +59(%D)",L"Дорога Быстроникольское Черская%1"},
	{L"^R +60(%D)",L"Дорога Псков Кингисепп Краколье%1"},
	{L"^R +61(%D)",L"Дорога Заполье Гдов%1"},
	{L"^R +62(%D)",L"Дорога Себеж граница с Белоруссией на Верхнедвинск%1"},
	{L"^R +63(%D)",L"Дорога Новоселье Боровичи Псковской области%1"},
	{L"^R +68(%D)",L"Дорога Брянск Киров Куземки%1"},
	{L"^R +71(%D)",L"Дорога Сенинские Дворики Кинешма%1"},
	{L"^R +72(%D)",L"Дорога Владимир Муром Арзамас%1"},
	{L"^R +73(%D)",L"Дорога Владимир Тума%1"},
	{L"^R +74(%D)",L"Дорога Владимир Переславль-Залесский%1"},
	{L"^R +75(%D)",L"Дорога Дворики Хрястово%1"},
	{L"^R +76(%D)",L"Дорога Гаврильцево Муром%1"},
	{L"^R +79(%D)",L"Дорога Иваново Гаврилов-Ям Ярославль%1"},
	{L"^R +80(%D)",L"Дорога Иваново Родники%1"},
	{L"^R +81(%D)",L"Дорога Кинешма Пурех%1"},
	{L"^R +84(%D)",L"Дорога Тверь Бежецк Устюжна%1"},
	{L"^R +85(%D)",L"Дорога Вышний Волочек Бежецк Углич%1"},
	{L"^R +86(%D)",L"Дорога Калязин Боровичи%1"},
	{L"^R +87(%D)",L"Дорога Осташков Ржев%1"},
	{L"^R +88(%D)",L"Дорога Торжок Старица%1"},
	{L"^R +89(%D)",L"Дорога Осташков Волговерховье%1"},
	{L"^R +90(%D)",L"Дорога Тверь Шаховская Уваровка%1"},
	{L"^R +91(%D)",L"Дорога Барановичи Осиповичи%1"},
	{L"^R +92(%D)",L"Дорога Калуга Орел%1"},
	{L"^R +93(%D)",L"Дорога Калуга Медынь%1"},
	{L"^R +94(%D)",L"Дорога Перемышль Козельск%1"},
	{L"^R +95(%D)",L"Дорога Голодское Одоев%1"},
	{L"^R +96(%D)",L"Дорога Новоалександровский Починок%1"},
	{L"^R +98(%D)",L"Дорога Кострома Верхнеспасское%1"},
	{L"^R +99(%D)",L"Дорога Кострома Буй%1"},
	{L"^R +100(%D)",L"Дорога Судиславль Чухлома%1"},
	{L"^R +101(%D)",L"Дорога Островское Заволжск%1"},
	{L"^R +104(%D)",L"Дорога Череповец Рыбинск Сергиев Посад до М8%1"},
	{L"^R +105(%D)",L"Егорьевское Шоссе%1"},
	{L"^R +106(%D)",L"Дорога Куровское Шатура Самойлиха%1"},
	{L"^R +107(%D)",L"Дорога Лотошино Клин%1"},
	{L"^R +108(%D)",L"Дорога Суворово Волоколамск Руза%1"},
	{L"^R +109(%D)",L"Дорога Анискино Монино Электроугли%1"},
	{L"^R +110(%D)",L"Дорога Щелково Фряново%1"},
	{L"^R +111(%D)",L"Волоколамское Шоссе%1"},
	{L"^R +112(%D)",L"Дорога Дмитров Талдом Темпы%1"},
	{L"^R +113(%D)",L"Рогачевское Шоссе%1"},
	{L"^R +114(%D)",L"Дорога Кашира Кимовск Узловая%1"},
	{L"^R +115(%D)",L"Дорога Егорьевск Коломна Ненашево%1"},
	{L"^R +116(%D)",L"Дорога Дубна Кимры Горицы%1"},
	{L"^R +119(%D)",L"Дорога Орел Липецк Тамбов%1"},
	{L"^R +120(%D)",L"Дорога Орел Ефремов%1"},
	{L"^R +123(%D)",L"Дорога Спас-Клепики Рязань%1"},
	{L"^R +124(%D)",L"Дорога Шацк Касимов%1"},
	{L"^R +125(%D)",L"Дорога Касимов Муром Нижний Новгород%1"},
	{L"^R +126(%D)",L"Дорога Рязань Ряжск Ефремов%1"},
	{L"^R +127(%D)",L"Дорога Пехлец Кораблино Скопин%1"},
	{L"^R +130(%D)",L"Дорога Демидов Рудня%1"},
	{L"^R +131(%D)",L"Дорога Велиж граница с Белоруссией на Витебск%1"},
	{L"^R +132(%D)",L"Дорога Вязьма Калуга Рязань%1"},
	{L"^R +133(%D)",L"Дорога Ольша Невель граница с Белоруссией на Клястицы%1"},
	{L"^R +134(%D)",L"Дорога Смоленск Вязьма Зубцов%1"},
	{L"^R +135(%D)",L"Дорога Смоленск Красный Гусево%1"},
	{L"^R +136(%D)",L"Дорога Витязи М1 Лисичино Нелидово%1"},
	{L"^R +137(%D)",L"Дорога Рославль Ельня Сафоново%1"},
	{L"^R +139(%D)",L"Дорога Тула Белев%1"},
	{L"^R +140(%D)",L"Дорога Тула Новомосковск%1"},
	{L"^R +141(%D)",L"Дорога Ефремов Лопотково%1"},
	{L"^R +142(%D)",L"Дорога Богородицк Товарковский Куркино%1"},
	{L"^R +143(%D)",L"Дорога Железня Алексин%1"},
	{L"^R +144(%D)",L"Дорога Малахово Заокский музей-заповедник Поленова%1"},
	{L"^R +145(%D)",L"Дорога Кимовск Куликово Поле Кресты%1"},
	{L"^R +146(%D)",L"Дорога Чекалин Суворов станция Ханино%1"},
	{L"^R +147(%D)",L"Дорога Чернь Медведки%1"},
	{L"^R +148(%D)",L"Дорога Щекино Одоев Арсеньево%1"},
	{L"^R +151(%D)",L"Дорога Ярославль Рыбинск%1"},
	{L"^R +152(%D)",L"Дорога Ростов Иваново Нижний Новгород%1"},
	{L"^R +153(%D)",L"Дорога Углич Ростов%1"},
	{L"^R +157(%D)",L"Дорога Урень Шарья Котлас%1"},
	{L"^R +158(%D)",L"Дорога Нижний Новгород Саранск Саратов%1"},
	{L"^R +159(%D)",L"Дорога Нижний Новгород Шахунья Яранск%1"},
	{L"^R +160(%D)",L"Дорога Линда Заволжье%1"},
	{L"^R +161(%D)",L"Дорога Навашино Линда%1"},
	{L"^R +162(%D)",L"Дорога Работки Сергач Порецкое%1"},
	{L"^R +166(%D)",L"Дорога Киров Белая Холуница%1"},
	{L"^R +167(%D)",L"Дорога Киров Цепели Стрижи%1"},
	{L"^R +168(%D)",L"Дорога Киров Адышево Нижнеивкино%1"},
	{L"^R +169(%D)",L"Дорога Киров Малмыж Вятские Поляны%1"},
	{L"^R +172(%D)",L"Дорога Йошкар-Ола Уржум%1"},
	{L"^R +173(%D)",L"Дорога Йошкар-Ола Чебоксары М7%1"},
	{L"^R +174(%D)",L"Дорога Йошкар-Ола Мариинский Посад Цивильск%1"},
	{L"^R +175(%D)",L"Дорога Казань Йошкар-Ола%1"},
	{L"^R +178(%D)",L"Дорога Ульяновск Саранск Торбеево до М5%1"},
	{L"^R +179(%D)",L"Дорога Саранск Рузаевка%1"},
	{L"^R +180(%D)",L"Дорога Саранск Новые Выселки%1"},
	{L"^R +185(%D)",L"Дорога Белгород Россошь%1"},
	{L"^R +186(%D)",L"Дорога Белгород граница с Украиной на Великую Писаревку%1"},
	{L"^R +187(%D)",L"Дорога Новый Оскол Валуйки Ровеньки%1"},
	{L"^R +188(%D)",L"Дорога Старый Оскол Новый Оскол%1"},
	{L"^R +189(%D)",L"Дорога Короча Горшечное Старый Оскол%1"},
	{L"^R +190(%D)",L"Дорога Лукьяновка Тим%1"},
	{L"^R +193(%D)",L"Дорога Воронеж Тамбов%1"},
	{L"^R +194(%D)",L"Дорога Воронеж Россошь Мимерово%1"},
	{L"^R +195(%D)",L"Дорога Россошь граница с Украиной на Старобельск%1"},
	{L"^R +196(%D)",L"Дорога Р194 Подгорное Павловск%1"},
	{L"^R +199(%D)",L"Дорога Курск граница с Украиной на Глухов%1"},
	{L"^R +200(%D)",L"Дорога Дьяконово граница с Украиной на Сумы%1"},
	{L"^R +203(%D)",L"Дорога Липецк Грязи Песковатка%1"},
	{L"^R +204(%D)",L"Дорога Липецк Мичуринск%1"},
	{L"^R +205(%D)",L"Дорога Липецк Данков%1"},
	{L"^R +208(%D)",L"Дорога Тамбов Рассказово Пенза%1"},
	{L"^R +209(%D)",L"Дорога Тамбов Пенза%1"},
	{L"^R +214(%D)",L"Дорога Астрахань Камызяк%1"},
	{L"^R +215(%D)",L"Дорога Астpахань Махачкала%1"},
	{L"^R +216(%D)",L"Дорога Астрахань Лиман%1"},
	{L"^R +217(%D)",L"Дорога Зензели Лиман Оля%1"},
	{L"^R +220(%D)",L"Дорога Волгоград аэропорт Гумрак%1"},
	{L"^R +224(%D)",L"Дорога Самара Пугачев Энгельс Волгоград%1"},
	{L"^R +225(%D)",L"Дорога Самара Бугуруслан%1"},
	{L"^R +227(%D)",L"Дорога Сызрань Шигоны Усолье%1"},
	{L"^R +228(%D)",L"Дорога Сызрань Саратов Волгоград%1"},
	{L"^R +231(%D)",L"Дорога Сурское Шумерля М7%1"},
	{L"^R +234(%D)",L"Дорога Ельшанка Песчаный Умет%1"},
	{L"^R +235(%D)",L"Дорога Балашов Ртищево%1"},
	{L"^R +236(%D)",L"Дорога Энгельс граница с Казахстаном на Уральск%1"},
	{L"^R +239(%D)",L"Дорога Казань Бугульма Р314%1"},
	{L"^R +240(%D)",L"Дорога Алексеевское Высокий Колок%1"},
	{L"^R +241(%D)",L"Дорога Казань Буинск Ульяновск%1"},
	{L"^R +242(%D)",L"Дорога Пермь Екатеринбург%1"},
	{L"^R +244(%D)",L"Дорога Казань туристический комплекс Волга%1"},
	{L"^R +245(%D)",L"Дорога Казань аэропорт Казань 2%1"},
	{L"^R +246(%D)",L"Дорога Бугульма граница с Казахстаном на Уральск%1"},
	{L"^R +250(%D)",L"Дорога Старощербиновская Ейск%1"},
	{L"^R +251(%D)",L"Дорога Темрюк Краснодар Кропоткин%1"},
	{L"^R +252(%D)",L"Дорога Андреева Гора Анапа%1"},
	{L"^R +253(%D)",L"Дорога Кореновск Белореченск Армавир%1"},
	{L"^R +254(%D)",L"Дорога Туапсе Майкоп Кавказский заповедник%1"},
	{L"^R +255(%D)",L"Дорога Армавир Отрадное%1"},
	{L"^R +256(%D)",L"Дорога Майкоп Гиагинская Псебай Карачаевск%1"},
	{L"^R +262(%D)",L"Дорога Ставрополь Моздок Крайновка%1"},
	{L"^R +263(%D)",L"Дорога Кочубей Hефтекумск Зеленокумск%1"},
	{L"^R +264(%D)",L"Дорога Пятигорск Георгиевск%1"},
	{L"^R +265(%D)",L"Дорога Черкесск Зеленчукская Архыз%1"},
	{L"^R +266(%D)",L"Дорога Светлоград Благодарный Буденновск%1"},
	{L"^R +267(%D)",L"Дорога Ставрополь аэропорт Шпаковское%1"},
	{L"^R +268(%D)",L"Дорога Батайск Краснодар%1"},
	{L"^R +269(%D)",L"Дорога Батайск Ставрополь%1"},
	{L"^R +270(%D)",L"Дорога Егорлыкская Сальск%1"},
	{L"^R +271(%D)",L"Дорога Миллерово Вешенская%1"},
	{L"^R +272(%D)",L"Дорога Мимерово граница с Украиной на Луганск%1"},
	{L"^R +275(%D)",L"Дорога Махачкала Буйнакск Гуниб%1"},
	{L"^R +276(%D)",L"Дорога Леваши Сергокала%1"},
	{L"^R +277(%D)",L"Дорога Гунибское шоссе Вантляшевский перевал%1"},
	{L"^R +278(%D)",L"Дорога Хасавюрт Тлох%1"},
	{L"^R +279(%D)",L"Дорога Хасавюрт Бабаюрт%1"},
	{L"^R +280(%D)",L"Дорога Манаскент Сергокала Первомайское%1"},
	{L"^R +281(%D)",L"Дорога Мамраш Ташкапур Араканский мост%1"},
	{L"^R +282(%D)",L"Дорога Буйнакск Кизилюрт%1"},
	{L"^R +283(%D)",L"Дорога Буйнакск Терменлик%1"},
	{L"^R +284(%D)",L"Дорога Каспийск махачкалинский аэропорт Уиташ%1"},
	{L"^R +285(%D)",L"Дорога Кочубей Нефтекумск Урожайное%1"},
	{L"^R +288(%D)",L"Дорога Нальчик Майский%1"},
	{L"^R +289(%D)",L"Дорога Прохладный Баксан%1"},
	{L"^R +290(%D)",L"Дорога Прохладный Эльхотов%1"},
	{L"^R +291(%D)",L"Дорога Махачкала Кизляр Уштулу%1"},
	{L"^R +292(%D)",L"Дорога Аргудан Александровская%1"},
	{L"^R +295(%D)",L"Дорога Владикавказ Ардон Старый Лескен%1"},
	{L"^R +296(%D)",L"Дорога Моздок Чермен Владикавказ%1"},
	{L"^R +297(%D)",L"Дорога Владикавказ Алагир аэропорт Беслан%1"},
	{L"^R +298(%D)",L"Дорога Алагир Карджин%1"},
	{L"^R +299(%D)",L"Дорога Гизель Кармадон Дзуарикау%1"},
	{L"^R +300(%D)",L"Дорога Дигора Минеральные источники%1"},
	{L"^R +301(%D)",L"Дорога Беслан Владикавказский аэропорт Беслан%1"},
	{L"^R +302(%D)",L"Дорога Чиколо Мацута Дзинага%1"},
	{L"^R +305(%D)",L"Дорога Грозный Шатой Итум-Кале%1"},
	{L"^R +306(%D)",L"Дорога Грозный Ботлих Араканы-Буйнакск%1"},
	{L"^R +307(%D)",L"Дорога Ищерская Грозный%1"},
	{L"^R +308(%D)",L"Дорога Червленная Грозный%1"},
	{L"^R +309(%D)",L"Дорога Гребенская Хасавюрт%1"},
	{L"^R +314(%D)",L"Дорога Уфа Оренбург подъезд к Мелеузу%1"},
	{L"^R +315(%D)",L"Дорога Уфа Бирск Янаул%1"},
	{L"^R +316(%D)",L"Дорога Стерлитамак Белорецк Магнитогорск%1"},
	{L"^R +317(%D)",L"Дорога Бирск Тастуба Сатка%1"},
	{L"^R +321(%D)",L"Дорога Игра Глазов%1"},
	{L"^R +322(%D)",L"Дорога Ижевск Сарапул%1"},
	{L"^R +327(%D)",L"Дорога Курган граница с Казахстаном на Кустанай%1"},
	{L"^R +328(%D)",L"Дорога Шумиха граница с Казахстаном на Кустанай%1"},
	{L"^R +329(%D)",L"Дорога Шадринск Ялуторовск%1"},
	{L"^R +330(%D)",L"Дорога Шадринск Миасское%1"},
	{L"^R +335(%D)",L"Дорога Оренбург граница с Казахстаном на Уральск%1"},
	{L"^R +336(%D)",L"Дорога Оренбург Орск%1"},
	{L"^R +337(%D)",L"Дорога Сара Самарское%1"},
	{L"^R +338(%D)",L"Дорога Адамовка Шильда Кваркено%1"},
	{L"^R +343(%D)",L"Дорога Кунгур Соликамск%1"},
	{L"^R +344(%D)",L"Дорога Кудымкар Краснокамск%1"},
	{L"^R +345(%D)",L"Дорога Пермь Усть-Качка%1"},
	{L"^R +351(%D)",L"Дорога Екатеринбург Тюмень%1"},
	{L"^R +352(%D)",L"Серовский Тракт%1"},
	{L"^R +353(%D)",L"Дорога Нижний Тагил Нижняя Салда%1"},
	{L"^R +354(%D)",L"Дорога Екатеринбург Шадринск Курган%1"},
	{L"^R +355(%D)",L"Дорога Екатеринбург Полевской%1"},
	{L"^R +360(%D)",L"Дорога Южноуральск Магнитогорск%1"},
	{L"^R +361(%D)",L"Дорога Магнитогорск Сибай Зилаир Ира%1"},
	{L"^R +366(%D)",L"Дорога Бийск Мартыново Новокузнецк%1"},
	{L"^R +367(%D)",L"Дорога Мартыново Тогул Залесово%1"},
	{L"^R +368(%D)",L"Дорога Бийск Белокуриха%1"},
	{L"^R +369(%D)",L"Дорога Катунское Красный Яр Черга%1"},
	{L"^R +370(%D)",L"Дорога Поспелиха Курья Третьякова%1"},
	{L"^R +371(%D)",L"Дорога Алейск граница с Казахстаном на Павлодар%1"},
	{L"^R +372(%D)",L"Дорога Родино Благовещенка%1"},
	{L"^R +373(%D)",L"Дорога Иня Усть-Кокса Туэкта%1"},
	{L"^R +374(%D)",L"Дорога Белоярск Заринск%1"},
	{L"^R +375(%D)",L"Дорога Бийск Турочак Артыбаш%1"},
	{L"^R +380(%D)",L"Дорога Новосибирск Камень-на-Оби Барнаул%1"},
	{L"^R +381(%D)",L"Дорога Здвинск Барабинск Куйбышев%1"},
	{L"^R +382(%D)",L"Дорога Ордынское граница с Казахстаном на Павлодар%1"},
	{L"^R +383(%D)",L"Дорога Кочки Каргат%1"},
	{L"^R +384(%D)",L"Дорога Новосибирск Кемерово Юрга%1"},
	{L"^R +390(%D)",L"Дорога Омск Русская Поляна%1"},
	{L"^R +391(%D)",L"Дорога Горьковское Калачинск Оконешниково%1"},
	{L"^R +392(%D)",L"Дорога Омск Р402 Тара%1"},
	{L"^R +393(%D)",L"Дорога Омск Кокчетов%1"},
	{L"^R +398(%D)",L"Дорога Томск Каргала Колпашево%1"},
	{L"^R +399(%D)",L"Дорога Каргала Бакчар%1"},
	{L"^R +400(%D)",L"Дорога Томск Мариинск%1"},
	{L"^R +401(%D)",L"Дорога Тюмень аэропорт Рощино%1"},
	{L"^R +402(%D)",L"Дорога Тюмень Ишим Омск%1"},
	{L"^R +402(%D)",L"Дорога Тюмень Ишим Омск%1"},
	{L"^R +403(%D)",L"Дорога Ишим граница с Казахстаном на Петропавловск%1"},
	{L"^R +404(%D)",L"Дорога Тюмень Тобольск Ханты-Мансийск%1"},
	{L"^R +409(%D)",L"Дорога Красноярск Енисейск%1"},
	{L"^R +410(%D)",L"Дорога Канск Троицк%1"},
	{L"^R +411(%D)",L"Дорога Абакан Саяногорск%1"},
	{L"^R +412(%D)",L"Дорога Шарыпово Ужур Балахта%1"},
	{L"^R +413(%D)",L"Дорога Заозерный Агинское%1"},
	{L"^R +418(%D)",L"Дорога Иркутск Усть-Ордынский%1"},
	{L"^R +419(%D)",L"Дорога Тулун Братск Осетрово%1"},
	{L"^R +420(%D)",L"Дорога Залари Жигалово%1"},
	{L"^R +425(%D)",L"Дорога Петровск-Забайкальский Чикой Ярмаровка%1"},
	{L"^R +426(%D)",L"Дорога Могойтуй Нерчинск Сретенск%1"},
	{L"^R +427(%D)",L"Дорога Нерчинск Чернышевск%1"},
	{L"^R +428(%D)",L"Дорога Нерчинск Шоноктуй%1"},
	{L"^R +429(%D)",L"Дорога Сретенск Нерчинский завод Олочи%1"},
	{L"^R +430(%D)",L"Дорога Нерчинский Соловьевск%1"},
	{L"^R +431(%D)",L"Дорога Онон Цаган-Олуй%1"},
	{L"^R +436(%D)",L"Дорога Улан-Удэ Чита%1"},
	{L"^R +437(%D)",L"Дорога Романовка Багдарин%1"},
	{L"^R +438(%D)",L"Дорога Улан-Удэ Курумкан%1"},
	{L"^R +439(%D)",L"Дорога Турунтаево Татаурово%1"},
	{L"^R +440(%D)",L"Дорога Гусиноозерск Закаменск%1"},
	{L"^R +441(%D)",L"Дорога Мухоршибир Бичура Кяхта%1"},
	{L"^R +442(%D)",L"Дорога Кяхта Наушки граница с Монголией%1"},
	{L"^R +447(%D)",L"Дорога Находка Кавалерово%1"},
	{L"^R +448(%D)",L"Дорога Лазо Заповедный%1"},
	{L"^R +449(%D)",L"Дорога Лесное Тихменево%1"},
	{L"^R +454(%D)",L"Дорога Биробиджан Новое%1"},
	{L"^R +456(%D)",L"Дорога Бирофельд Биджан%1"},
	{L"^R +461(%D)",L"Дорога Благовещенск Облучье%1"},
	{L"^R +463(%D)",L"Дорога Толстовка Березовка%1"},
	{L"^R +464(%D)",L"Дорога Завитинск Поярково%1"},
	{L"^R +465(%D)",L"Дорога Екатеринославка Константиновка%1"},
	{L"^R +466(%D)",L"Дорога Райчихинск Бурея Новобурейский%1"},
	{L"^R +467(%D)",L"Дорога Архара Иннокентьевка%1"},
	{L"^R +468(%D)",L"Дорога Благовещенск Свободный%1"},
	{L"^R +469(%D)",L"Дорога Белогорск Новотроицкое%1"},
	{L"^R +474(%D)",L"Дорога Петропавловск-Камчатский Мильково%1"},
	{L"^R +475(%D)",L"Дорога Елизово Паратунка%1"},
	{L"^R +481(%D)",L"Дорога Магадан Балаганное Талон%1"},
	{L"^R +482(%D)",L"Дорога Магадан Солнечный Ола%1"},
	{L"^R +487(%D)",L"Дорога Южно-Сахалинск Александров-Сахалинский%1"},
	{L"^R +488(%D)",L"Дорога Корсаков Южно-Сахалинск Холмск%1"},
	{L"^R +489(%D)",L"Дорога Арсентьевка Ильинский%1"},
	{L"^R +490(%D)",L"Дорога Гастелло Углегорск%1"},
	{L"^R +491(%D)",L"Дорога Смирных Бошняково%1"},
	{L"^R +492(%D)",L"Дорога Южно-Сахалинск Анива Атласово%1"},
	{L"^R +493(%D)",L"Дорога Анива Ловецкое%1"},
	{L"^R +495(%D)",L"Дорога Южно-Сахалинск Холмск%1"},
	{L"^R +501(%D)",L"Дорога Якутск Вестях%1"},
	{L"^R +502(%D)",L"Дорога Якутск Амга%1"},
	{L"^R +503(%D)",L"Дорога Якутск Намцы%1"},
	{L"^R +508(%D)",L"Дорога Калининград Гусев Неман%1"},
	{L"^R +509(%D)",L"Дорога Добровольск Кутузово%1"},
	{L"^R +510(%D)",L"Дорога Добровольск граница с Польшей%1"},
	{L"^R +511(%D)",L"Дорога Краснознаменск Победино Р510%1"},
	{L"^R +512(%D)",L"Дорога Полесск Гвардейск Правдинск%1"},
	{L"^R +513(%D)",L"Дорога Советск Славск Мысовка%1"},
	{L"^R +514(%D)",L"Дорога Зорино Красное%1"},
	{L"^R +515(%D)",L"Дорога Зеленоградск Морское%1"},
	{L"^R +516(%D)",L"Дорога Калининград граница с Польшей%1"},
	{L"^R +517(%D)",L"Дорога Черняховск Озерск%1"},
	{L"/",L""},
}
VOICE["replace_mapinfo" .. mother_country] = {
	{L"(.*)",L" %1 "},
	{L",",L" , "},
	{L"%([%S ]+%)",L" "},
	{L" %d+%.%d+ ",L" "},
	{L" (%d+)",L"  %1"},
	{L" (%S)%.( ?)(%S)%. ", function (s1, s2, s3)
		if smart_lower_case_get_codegroup(wstring.byte(s1,1)) and smart_lower_case_get_codegroup(wstring.byte(s3,1)) then return L" " end
		return L" "..s1..L"."..s2..s3..L". " end},
	{L"Ак%.",L"Академика "},
	{L"Ал%.",L"Аллея "},
	{L"Бол%.",L"Большая "},
	{L"Бул(ьв)?%.",L"Бульвар "},
	{L"Дор%. Без Имени",L" "},
	{L"Дорога Без Имени",L" "},
	{L"Екад ",L"Кольцевая Автодорога "},
	{L"Им[%. ]",L" Имени "},
	{L"Кад ",L"Кольцевая Автодорога "},
	{L"Км%.",L"Километр "},
	{L"Наб[%. ]",L"Набережная "},
	{L"Пер%.",L"Переулок "},
	{L"Пл%.",L"Площадь "},
	{L"Пр%-д ",L"Проезд "},
	{L"Пр ?%- ?т ",L"Проспект "},	
	{L"(.*)Пр[%. ](.*)", function (s1, s3)
		local s2 = L" Проспект "
		local t = {L"Шмитовский", L"Серебрякова"}
		for _,v in ipairs(t) do
			if wstring.find(s1..s3,v) then s2 = L" Проезд " break end
		end
		return s1..s2..s3 end},
	{L"Просп%.",L"Проспект "},
	{L"Ст%.",L"Станция "},
	{L"Туп%.",L"Тупик "},
	{L"У[дл][%. ]",L"Улица "},
	{L" ш[%. ]",L" Шоссе "},
	{L"В Михайловский",L"Верхний Михайловский"},
	{L"Верх%. ?Сыромятническая",L"Верхняя Сыромятническая"},
	{L"Влксм",L"Комсомола"},
	{L"ние +Поля",L"ние Поля_"},
	{L"н%. ?Новгород[, ]",L"Нижний Новгород"},
	{L"Поля Фильтрации",L"Поля_ Фильтрации"},
	{L"Хх%-",L"20-"},
	{L"Brateyevo",L"Братеево"},
	{L"Domodedowo",L"Домодедово"},
	{L"Dzhubga",L"Джубга"},
	{L"Khimki",L"Химки"},
	{L"N%. ?Novgorod",L"Нижний Новгород"},
	{L"Podolьsk",L"Подольск"},
	{L"Sheremetyevo",L"Шереметьево"},
	{L"Sheremetъevo",L"Шереметьево"},
	{L"Shcherbinka",L"Щербинка"},
	{L"Volokolamsk",L"Волоколамск"},
	{L"St%.",L"Sankt "},
	{L"|",L""},
}
local mapinfo_numbers = {
	{L"", L"двух", L"трёх", L"четырёх", L"пяти", L"шести", L"семи", L"восьми", L"девяти"},
	{L"один", L"две", L"три", L"четыр", L"пят", L"шест", L"сем", L"восем", L"девят"},
	{L"", L"двадцать", L"тридцать", L"сорок", L"пятьдесят", L"шестьдесят", L"семьдесят", L"восемьдесят", L"девяносто"},
	{L"сто", L"двести", L"триста", L"четыреста", L"пятьсот", L"шестьсот", L"семьсот", L"восемьсот", L"девятьсот"},
	{L"тысяча", L"две тысячи", L"три тысячи", L"четыре тысячи", L"пять тысяч", L"шесть тысяч", L"семь тысяч", L"восемь тысяч", L"девять тысяч"},
}
VOICE["replace_mapinfo_numbers" .. mother_country] = {
	{L" 26[%- ]?Т?и? Бакинских ",L" двадцати шести Бакинских "},
	{L" (%d+)%-Т?и Летия ",L" %1 Летия "},
	{L"%-й Конной Лахты",L"-Ой Конной Лахты"},
	{L"(.*)", function (s)
		local matched = 0
		wstring.gsub(s, L"(%d+)", function() matched = matched + 1 end)
		return (matched >= 2 and L"||" or L"")..wstring.gsub(s, L"Имени ", L"|Имени ") end},
	{L"(%d+) +(%S+)", function (s1,s2)
		local t = {L"Года", L"Партсъезда", L"Января", L"Февраля", L"Марта", L"Апреля", L"Мая", L"Июня", L"Июля", L"Августа", L"Сентября", L"Октября", L"Ноября", L"Декабря"}
		local suffix = L""
		for _,v in ipairs(t) do
			if s2==v then suffix = L"-о" break end
		end
		if s2==L"Километр" then suffix = L"-й" end
		if s2==L"Линия" then suffix = L"-я" end
		if s2==L"Пятилетки" then suffix = L"-Ой" end
		return s1..suffix..L" "..s2 end},
	{L"(%D+) (%d+) (%D+)", function (s1,s2,s3)
		local suffix = L""
		if wstring.find(s1..s3,L"Проезд") then suffix = L"-й" end
		if wstring.find(s3,L"Дивизии") then suffix = L"-Ой" end
		return s1..L" "..s2..suffix..L" "..s3 end},
	{L"(%d+)-й (%D+)", function (s1,s2)
		local t = {L"Дивизии", L"Армии", L"Батареи", L"Линии"}
		local suffix = L"-й"
		for _,v in ipairs(t) do
			if wstring.find(s2,v) then suffix = L"-Ой" break end
		end
		return s1..suffix..L" "..s2 end},

	{L" (%d)000[%- ]?А?я ", function (s) return L" |"..mapinfo_numbers[1][tonumber(s)]..L"тысячная| " end},
	{L" (%d)000[%- ]?Ой ", function (s) return L" "..mapinfo_numbers[1][tonumber(s)]..L"тысячной " end},
	{L" (%d)000[%- ]?Ы?й ", function (s) return L" |"..mapinfo_numbers[1][tonumber(s)]..L"тысячный| " end},
	{L" (%d)000[%- ]?О?е ", function (s) return L" |"..mapinfo_numbers[1][tonumber(s)]..L"тысячное| " end},
	{L" (%d)000[%- ]?Г?о ", function (s) return L" "..mapinfo_numbers[1][tonumber(s)]..L"тысячного " end},
	{L" (%d)000[%- ]?Летия ", function (s) return L" "..mapinfo_numbers[1][tonumber(s)]..L"тысячелетия " end},
	{L" (%d)(%d)(%d)(%d)[%- ]?[АЬ]?я ", function (s1,s2,s3,s4) if s2==L"0" then s2=L"" if s3==L"0" then s3=L"" end end return L" |"..mapinfo_numbers[5][tonumber(s1)]..L" "..s2..s3..s4..L"-я " end},
	{L" (%d)(%d)(%d)(%d)[%- ]?[ОЕ]й ", function (s1,s2,s3,s4) if s2==L"0" then s2=L"" if s3==L"0" then s3=L"" end end return L" |"..mapinfo_numbers[5][tonumber(s1)]..L" "..s2..s3..s4..L"-Ой " end},
	{L" (%d)(%d)(%d)(%d)[%- ]?[ЫИ]?й ", function (s1,s2,s3,s4) if s2==L"0" then s2=L"" if s3==L"0" then s3=L"" end end return L" |"..mapinfo_numbers[5][tonumber(s1)]..L" "..s2..s3..s4..L"-й " end},
	{L" (%d)(%d)(%d)(%d)[%- ]?[ОЬ]?е ", function (s1,s2,s3,s4) if s2==L"0" then s2=L"" if s3==L"0" then s3=L"" end end return L" |"..mapinfo_numbers[5][tonumber(s1)]..L" "..s2..s3..s4..L"-е " end},
	{L" (%d)(%d)(%d)(%d)[%- ]?Г?о ", function (s1,s2,s3,s4) if s2==L"0" then s2=L"" if s3==L"0" then s3=L"" end end return L" "..mapinfo_numbers[5][tonumber(s1)]..L" "..s2..s3..s4..L"-о " end},
	{L" (%d)(%d)(%d)(%d)[%- ]?Летия ", function (s1,s2,s3,s4) if s2==L"0" then s2=L"" if s3==L"0" then s3=L"" end end return L" "..mapinfo_numbers[5][tonumber(s1)]..L" "..s2..s3..s4..L"-Летия " end},
	{L" (%d)00[%- ]?А?я ", function (s) return L" |"..mapinfo_numbers[1][tonumber(s)]..L"сотая| " end},
	{L" (%d)00[%- ]?Ой ", function (s) return L" |"..mapinfo_numbers[1][tonumber(s)]..L"сотой| " end},
	{L" (%d)00[%- ]?Ы?й ", function (s) return L" |"..mapinfo_numbers[1][tonumber(s)]..L"сотый| " end},
	{L" (%d)00[%- ]?О?е ", function (s) return L" |"..mapinfo_numbers[1][tonumber(s)]..L"сотое| " end},
	{L" (%d)00[%- ]?Г?о ", function (s) return L" "..mapinfo_numbers[1][tonumber(s)]..L"сотого " end},
	{L" (%d)00[%- ]?Летия ", function (s)
		local t = {L"сто", L"двухсот", L"трёхсот", L"четырёхсот", L"пятьсот", L"шестьсот", L"семьсот", L"восемьсот", L"девятьсот"}
		return L" "..t[tonumber(s)]..L"летия " end},
	{L" (%d)(%d)(%d)[%- ]?[АЬ]?я ", function (s1,s2,s3) if s2==L"0" then s2=L"" end return L" |"..mapinfo_numbers[4][tonumber(s1)]..L" "..s2..s3..L"-я " end},
	{L" (%d)(%d)(%d)[%- ]?[ОЕ]й ", function (s1,s2,s3) if s2==L"0" then s2=L"" end return L" |"..mapinfo_numbers[4][tonumber(s1)]..L" "..s2..s3..L"-Ой " end},
	{L" (%d)(%d)(%d)[%- ]?[ЫИ]?й ", function (s1,s2,s3) if s2==L"0" then s2=L"" end return L" |"..mapinfo_numbers[4][tonumber(s1)]..L" "..s2..s3..L"-й " end},
	{L" (%d)(%d)(%d)[%- ]?[ОЬ]?е ", function (s1,s2,s3) if s2==L"0" then s2=L"" end return L" |"..mapinfo_numbers[4][tonumber(s1)]..L" "..s2..s3..L"-е " end},
	{L" (%d)(%d)(%d)[%- ]?Г?о ", function (s1,s2,s3) if s2==L"0" then s2=L"" end return L" "..mapinfo_numbers[4][tonumber(s1)]..L" "..s2..s3..L"-о " end},
	{L" (%d)(%d)(%d)[%- ]?Летия ", function (s1,s2,s3) if s2==L"0" then s2=L"" end return L" "..mapinfo_numbers[4][tonumber(s1)]..L" "..s2..s3..L"-Летия " end},
	{L" (%d)0[%- ]?А?я ", function (s)
		local t = {L"десятая", L"двадцатая", L"тридцатая", L"сороковая", L"пятидесятая", L"шестидесятая", L"семидесятая", L"восьмидесятая", L"девяностая"}
		return L" |"..t[tonumber(s)]..L"| " end},
	{L" (%d)0[%- ]?Ой ", function (s)
		local t = {L"десятой", L"двадцатой", L"тридцатой", L"сороковой", L"пятидесятой", L"шестидесятой", L"семидесятой", L"восьмидесятой", L"девяностой"}
		return L" |"..t[tonumber(s)]..L"| " end},
	{L" (%d)0[%- ]?Ы?й ", function (s)
		local t = {L"десятый", L"двадцатый", L"тридцатый", L"сороковой", L"пятидесятый", L"шестидесятый", L"семидесятый", L"восьмидесятый", L"девяностый"}
		return L" |"..t[tonumber(s)]..L"| " end},
	{L" (%d)0[%- ]?О?е ", function (s)
		local t = {L"десятое", L"двадцатое", L"тридцатое", L"сороковое", L"пятидесятое", L"шестидесятое", L"семидесятое", L"восьмидесятое", L"девяностое"}
		return L" |"..t[tonumber(s)]..L"| " end},
	{L" (%d)0[%- ]?Г?о ", function (s)
		local t = {L"десятого", L"двадцатого", L"тридцатого", L"сорокового", L"пятидесятого", L"шестидесятого", L"семидесятого", L"восьмидесятого", L"девяностого"}
		return L" "..t[tonumber(s)]..L" " end},
	{L" (%d)0[%- ]?Летия ", function (s)
		local t = {L"десяти", L"двадцати", L"тридцати", L"сорока", L"пятидесяти", L"шестидесяти", L"семидесяти", L"восьмидесяти", L"девяносто"}
		return L" "..t[tonumber(s)]..L"летия " end},
	{L" 1(%d)[%- ]?А?я ", function (s) return L" |"..mapinfo_numbers[2][tonumber(s)]..L"надцатая| " end},
	{L" 1(%d)[%- ]?Ой ", function (s) return L" |"..mapinfo_numbers[2][tonumber(s)]..L"надцатой| " end},
	{L" 1(%d)[%- ]?Ы?й ", function (s) return L" |"..mapinfo_numbers[2][tonumber(s)]..L"надцатый| " end},
	{L" 1(%d)[%- ]?О?е ", function (s) return L" |"..mapinfo_numbers[2][tonumber(s)]..L"надцатое| " end},
	{L" 1(%d)[%- ]?Г?о ", function (s) return L" "..mapinfo_numbers[2][tonumber(s)]..L"надцатого " end},
	{L" 1(%d)[%- ]?Летия ", function (s)
		local t = {L"одиннадцати", L"двенадцати", L"тринадцати", L"четырнадцати", L"пятнадцати", L"шестнадцати", L"семнадцати", L"восемнадцати", L"девятнадцати"}
		return L" "..t[tonumber(s)]..L"летия " end},
	{L" (%d)(%d)[%- ]?[АЬ]?я ", function (s1,s2) return L" |"..mapinfo_numbers[3][tonumber(s1)]..L" "..s2..L"-я " end},
	{L" (%d)(%d)[%- ]?[ОЕ]й ", function (s1,s2) return L" |"..mapinfo_numbers[3][tonumber(s1)]..L" "..s2..L"-Ой " end},
	{L" (%d)(%d)[%- ]?[ЫИ]?й ", function (s1,s2) return L" |"..mapinfo_numbers[3][tonumber(s1)]..L" "..s2..L"-й " end},
	{L" (%d)(%d)[%- ]?[ОЬ]?е ", function (s1,s2) return L" |"..mapinfo_numbers[3][tonumber(s1)]..L" "..s2..L"-е " end},
	{L" (%d)(%d)[%- ]?Г?о ", function (s1,s2) return L" "..mapinfo_numbers[3][tonumber(s1)]..L" "..s2..L"-о " end},
	{L" (%d)(%d)[%- ]?Летия ", function (s1,s2)
		local t = {L"", L"двадцати", L"тридцати", L"сорока", L"пятидесяти", L"шестидесяти", L"семидесяти", L"восьмидесяти", L"девяносто"}
		return L" "..t[tonumber(s1)]..L" "..s2..L"-Летия " end},
	{L" (%d)[%- ]?[АЬ]?я ", function (s)
		local t = {L"первая", L"вторая", L"третья", L"четвёртая", L"пятая", L"шестая", L"седьмая", L"восьмая", L"девятая"}
		return L" |"..t[tonumber(s)]..L"| " end},
	{L" (%d)[%- ]?[ОЕ]й ", function (s)
		local t = {L"первой", L"второй", L"третьей", L"четвёртой", L"пятой", L"шестой", L"седьмой", L"восьмой", L"девятой"}
		return L" |"..t[tonumber(s)]..L"| " end},
	{L" (%d)[%- ]?[ЫИ]?й ", function (s)
		local t = {L"первый", L"второй", L"третий", L"четвёртый", L"пятый", L"шестой", L"седьмой", L"восьмой", L"девятый"}
		return L" |"..t[tonumber(s)]..L"| " end},
	{L" (%d)[%- ]?[ОЬ]?е ", function (s)
		local t = {L"первое", L"второе", L"третье", L"четвёртое", L"пятое", L"шестое", L"седьмое", L"восьмое", L"девятое"}
		return L" |"..t[tonumber(s)]..L"| " end},
	{L" (%d)[%- ]?Г?о ", function (s)
		local t = {L"первого", L"второго", L"третьего", L"четвёртого", L"пятого", L"шестого", L"седьмого", L"восьмого", L"девятого"}
		return L" "..t[tonumber(s)]..L" " end},
	{L" (%d)[%- ]?Летия ", function (s)
		local t = {L"одно", L"двух", L"трёх", L"четырёх", L"пяти", L"шести", L"семи", L"восьми", L"девяти"}
		return L" "..t[tonumber(s)]..L"летия " end},

	{L"^||(.*)",function (s) return wstring.gsub(s, L"|", L"") end},
	{L"|(.*)|", function (s) return L"|"..wstring.gsub(s, L"|",L"")..L"|" end},
}
VOICE["replace_mapinfo_end" .. mother_country] = {
	{L" +м[%. ]+(.* +Улица) +",L" Малая %1 "},
	{L" +б[%. ]+(.* +Улица) +",L" Большая %1 "},
	{L" +м[%. ]+(.* +Переулок) +",L" Малый %1 "},
	{L" +б[%. ]+(.* +Переулок) +",L" Большой %1 "},
	{L" +м[%. ]+(.* +Тупик) +",L" Малый %1 "},
	{L" +б[%. ]+(.* +Тупик) +",L" Большой %1 "},
	{L" +м[%. ]+(.* +Проезд) +",L" Малый %1 "},
	{L" +б[%. ]+(.* +Проезд) +",L" Большой %1 "},
	{L" +в[%. ]+(.* +Улица) +",L" Верхняя %1 "},
	{L" +н[%. ]+(.* +Улица) +",L" Нижняя %1 "},
	{L" +в[%. ]+(.* +Переулок) +",L" Верхний %1 "},
	{L" +н[%. ]+(.* +Переулок) +",L" Нижний %1 "},
	{L" +в[%. ]+(.* +Проезд) +",L" Верхний %1 "},
	{L" +н[%. ]+(.* +Проезд) +",L" Нижний %1 "},
-- Слова "большой", "малый" и т.д. переносятся в начало строки: "1-ая большая улица" -> "большая первая улица"
	{L"(.*) +(Большой) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Большая) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Большое) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Большые) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Малый) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Малая) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Малое) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Малые) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Верхний) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Верхняя) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Верхнее) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Верхние) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Нижний) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Нижняя) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Нижнее) +(.*)",L" %2 %1 %3 "},
	{L"(.*) +(Нижние) +(.*)",L" %2 %1 %3 "},
-- Слова "первый", "второй" и т.д. переносятся в начало строки: "советская 1-я улица" -> "первая советская улица", "улица советская 1-ая" -> "первая улица советская"
	{L"(.*)|(.*)|(.*)",L" %2 %1 %3 "},
	{L" (%S)%.", function (s) if smart_lower_case_get_codegroup(wstring.byte(s,1)) then return L" " end return L" "..s..L". " end},
	{L"^(%u)(%u)[ ?]*(%d+)",L"%1.%2. %3"},
	{L"%-(%d+)",L" %1"},
	{L"(%d)(%a)",L"%1 %2"},
	{L"(%a)(%d)",L"%1 %2"},
	{L"//",L", "},
	{L" +",L" "},
	{L"^ ",L""},
	{L" $",L""},
}
VOICE["replace_mapinfo_inner" .. mother_country] = {}
VOICE["replace_mapinfo_inner2" .. mother_country] = {}
VOICE["match_inner" .. mother_country] = {}
VOICE["replace_tmc_description" .. mother_country] = {}
local replace_for_turns = {
	{L"(.*)",L" %1 "},
}
local replace_for_turns_end = {
	{L" +",L" "},
	{L"^ ",L""},
	{L" $",L""},
}
local replace_for_turns_inner = {
	{L"(.*) Дорога ",L" Дорогу %1 "},
	{L"(.*) Набережная ",L" Набережную %1 "},
	{L"(.*) Проезд ",L" Проезд %1 "},
	{L"(.*) Станция ",L" Станцию %1 "},
}
local replace_for_turns_inner2 = {
	{L"(.*) Аллея ",L" Аллею %1 "},
	{L"(.*) Бульвар ",L" Бульвар %1 "},
	{L"(.*) Выезд ",L" Выезд %1 "},
	{L"(.*) Въезд ",L" Въезд %1 "},
	{L"(.*) Микрорайон ",L" Микрорайон %1 "},
	{L"(.*) Мост ",L" Мост %1 "},
	{L"(.*) Переезд ",L" Переезд %1 "},
	{L"(.*) Переулок ",L" Переулок %1 "},
	{L"(.*) Площадь ",L" Площадь %1 "},
	{L"(.*) Проспект ",L" Проспект %1 "},
	{L"(.*) Спуск ",L" Спуск %1 "},
	{L"(.*) Трасса ",L" Трассу %1 "},
	{L"(.*) Тупик ",L" Тупик %1 "},
	{L"(.*) Улица ",L" Улицу %1 "},
	{L" Кольцевая Автодорога ",L" Кольцевую Автодорогу "},
}
local replace_for_directions_inner = {
	{L"(.*) Дорога ",L" Дороге %1 "},
	{L"(.*) Набережная ",L" Набережной %1 "},
	{L"(.*) Проезд ",L" Проезду %1 "},
	{L"(.*) Станция ",L" Станции %1 "},
}
local replace_for_directions_inner2 = {
	{L"(.*) Аллея ",L" Аллее %1 "},
	{L"(.*) Бульвар ",L" Бульвару %1 "},
	{L"(.*) Выезд ",L" Выезду %1 "},
	{L"(.*) Въезд ",L" Въезду %1 "},
	{L"(.*) Микрорайон ",L" Микрорайону %1 "},
	{L"(.*) Мост ",L" Мосту %1 "},
	{L"(.*) Переезд ",L" Переезду %1 "},
	{L"(.*) Переулок ",L" Переулку %1 "},
	{L"(.*) Площадь ",L" Площади %1 "},
	{L"(.*) Проспект ",L" Проспекту %1 "},
	{L"(.*) Спуск ",L" Спуску %1 "},
	{L"(.*) Трасса ",L" Трассе %1 "},
	{L"(.*) Тупик ",L" Тупику %1 "},
	{L"(.*) Улица ",L" Улице %1 "},
	{L" Кольцевая Автодорога ",L" Кольцевой Автодороге "},
	{L" Третье Транспортное Кольцо ",L" Третьему Транспортному Кольцу "},
}
local replace_for_traffic_fromto_inner = {
	{L"(.*) Дорога ",L" Дороги %1 "},
	{L"(.*) Набережная ",L" Набережной %1 "},
	{L"(.*) Проезд ",L" Проезда %1 "},
	{L"(.*) Станция ",L" Станции %1 "},
}
local replace_for_traffic_fromto_inner2 = {
	{L"(.*) Аллея ",L" Аллеи %1 "},
	{L"(.*) Бульвар ",L" Бульвара %1 "},
	{L"(.*) Выезд ",L" Выезда %1 "},
	{L"(.*) Въезд ",L" Въезда %1 "},
	{L"(.*) Микрорайон ",L" Микрорайона %1 "},
	{L"(.*) Мост ",L" Моста %1 "},
	{L"(.*) Переезд ",L" Переезда %1 "},
	{L"(.*) Переулок ",L" Переулка %1 "},
	{L"(.*) Площадь ",L" Площади %1 "},
	{L"(.*) Проспект ",L" Проспекта %1 "},
	{L"(.*) Спуск ",L" Спуска %1 "},
	{L"(.*) Трасса ",L" Трассы %1 "},
	{L"(.*) Тупик ",L" Тупика %1 "},
	{L"(.*) Улица ",L" Улицы %1 "},
	{L" Кольцевая Автодорога ",L" Кольцевой Автодороги "},
	{L" Третье Транспортное Кольцо ",L" Третьего Транспортного Кольца "},
}
local replace_for_traffic_on_inner = {
	{L"(.*) Дорога ",L" Дороге %1 "},
	{L"(.*) Набережная ",L" Набережной %1 "},
	{L"(.*) Проезд ",L" Проезде %1 "},
	{L"(.*) Станция ",L" Станции %1 "},
}
local replace_for_traffic_on_inner2 = {
	{L"(.*) Аллея ",L" Аллее %1 "},
	{L"(.*) Бульвар ",L" Бульваре %1 "},
	{L"(.*) Выезд ",L" Выезде %1 "},
	{L"(.*) Въезд ",L" Въезде %1 "},
	{L"(.*) Микрорайон ",L" Микрорайоне %1 "},
	{L"(.*) Мост ",L" Мосту %1 "},
	{L"(.*) Переезд ",L" Переезде %1 "},
	{L"(.*) Переулок ",L" Переулке %1 "},
	{L"(.*) Площадь ",L" Площади %1 "},
	{L"(.*) Проспект ",L" Проспекте %1 "},
	{L"(.*) Спуск ",L" Спуске %1 "},
	{L"(.*) Трасса ",L" Трассе %1 "},
	{L"(.*) Тупик ",L" Тупике %1 "},
	{L"(.*) Улица ",L" Улице %1 "},
	{L" Кольцевая Автодорога ",L" Кольцевой Автодороге "},
	{L" Третье Транспортное Кольцо ",L" Третьем Транспортном Кольце "},
}
local replace_for_summary_inner = {
	{L"(.*) Дорога ",L" Дорога %1 "},
	{L"(.*) Набережная ",L" Набережная %1 "},
	{L"(.*) Проезд ",L" Проезд %1 "},
	{L"(.*) Станция ",L" Станция %1 "},
}
local replace_for_summary_inner2 = {
	{L"(.*) Аллея ",L" Аллея %1 "},
	{L"(.*) Бульвар ",L" Бульвар %1 "},
	{L"(.*) Выезд ",L" Выезд %1 "},
	{L"(.*) Въезд ",L" Въезд %1 "},
	{L"(.*) Микрорайон ",L" Микрорайон %1 "},
	{L"(.*) Мост ",L" Мост %1 "},
	{L"(.*) Переезд ",L" Переезд %1 "},
	{L"(.*) Переулок ",L" Переулок %1 "},
	{L"(.*) Площадь ",L" Площадь %1 "},
	{L"(.*) Проспект ",L" Проспект %1 "},
	{L"(.*) Спуск ",L" Спуск %1 "},
	{L"(.*) Трасса ",L" Трасса %1 "},
	{L"(.*) Тупик ",L" Тупик %1 "},
	{L"(.*) Улица ",L" Улица %1 "},
}
local replace_sentence={
        {L"/",L" , "}, 
	{L" +",L" "},
	{L" затем ",L" , затем "},
	{L" там ",L" , там "},
}
local function get_preposition(str, tbl)
	for k,value in ipairs(tbl) do
		for _,pattern in ipairs(tbl[k][2]) do
			if wstring.find(str,pattern) then
				return tbl[k][1]
			end
		end
	end
end

----------------------------------------------------------------------------------------------------
----------------------------------------|  G U I D A N C E  |---------------------------------------
----------------------------------------------------------------------------------------------------

local function not_settlement(str)
	if transform_pattern_match(str,preposition_tbl) then return L"" end
        return get_preposition(str, preposition_insert_tbl)
end
local function wlocalize_table(tname,tcountry)
	if tcountry == mother_country then return VOICE[tname .. mother_country] end
	local localized = ""
	for _,v in pairs(wlocalized.countries) do
		if v == tcountry then localized = v break end
	end
	local need_load = localized ~= ""
	if need_load then need_load = not wlocalized["loaded"..localized] end
	if need_load then pcall(dofile, L"%app%/config/config_transforms"..towstring(localized)..L".lua") end
	if type(VOICE[tname .. localized]) ~= "table" then localized = mother_country end
	return VOICE[tname .. localized]
end  
local function check_unknown_country(country)
	if country == nil then
		MODEL.other.country_info.select_country_by_pos(MODEL.navigation.car.position())
		local countryindex = MODEL.other.country_info.list.index()
		if countryindex ~= nil then
			country = MODEL.other.country_info.list[countryindex].name()
		end
	end
	return string.lower(country)
end

local function format_mapinfo(str, country)
	country = check_unknown_country(country)
	str = smart_lower_case(str)
	local replace_mapinfo_inner_need,_ = transform_pattern_match(str..L" ",wlocalize_table("match_inner",country))
	str = transform_and_format(transform_and_format(transform_and_format(str, wlocalize_table("replace_mapinfo",country)), replace_mapinfo_inner_need and wlocalize_table("replace_mapinfo_inner",country)), wlocalize_table("replace_mapinfo_inner2",country))
	local replace_mapinfo_numbers_need = wstring.find(str,L"%d")
	return transform_and_format(transform_and_format(str, replace_mapinfo_numbers_need and wlocalize_table("replace_mapinfo_numbers",country)), wlocalize_table("replace_mapinfo_end",country))
end

local function format_roadnumber(number, country)
	country = check_unknown_country(country)
	local str = transform_format_roadnumber_eu(transform_and_format(number, replace_roadnumber_prepare))
	local need2text = roadnumber_mode
	if VOICE["replace_roadnumber" .. mother_country] == wlocalize_table("replace_roadnumber",country) and need2text then need2text = country == mother_country end
	local str1 = transform_and_format(str, need2text and wlocalize_table("replace_roadnumber",country))
	if str1 == str then
		str1 = wstring.gsub(str1,L"E +",L"Е ")
		str1 = wstring.gsub(str1,L",",L" , ")
	elseif wstring.find(number,L"/") then
		str1 = wstring.gsub(str1,L"(.*),(.*)",L"%1")
	end
	return format_all_numbers2text(str1)
end

local function format_cases(str, case, mapinfo)
	local str_input = str
	str=transform_and_format(str, replace_for_turns)
	local t_inner = replace_for_turns_inner
	local t_inner2 = replace_for_turns_inner2
	if case == "for_directions" then 
		t_inner = replace_for_directions_inner
		t_inner2 = replace_for_directions_inner2
	elseif case == "for_summary" then 
		t_inner = replace_for_summary_inner
		t_inner2 = replace_for_summary_inner2
	elseif case == "for_traffic_on" then 
		t_inner = replace_for_traffic_on_inner
		t_inner2 = replace_for_traffic_on_inner2
	elseif case == "for_traffic_fromto" then 
		t_inner = replace_for_traffic_fromto_inner
		t_inner2 = replace_for_traffic_fromto_inner2
	end
	if not wstring.find(str, main_streetname) then str = transform_and_format(str, t_inner) end
	str = transform_and_format(transform_and_format(str, t_inner2), replace_for_turns_end)
	if wstring.find(str,L"%d$") then str = format_all_numbers2text(str) end
	if mapinfo == nil or not (case == "for_turns" or case == "for_traffic_on") or str == L"" then 
		return str
	else
		return not_settlement(str_input) .. str
	end
end

local function format_tmc_description(str, country)
	country = check_unknown_country(country)
	return transform_and_format(wstring.lower(str), wlocalize_table("replace_tmc_description",country))
end

local function signpost_exit(data, idx)
	local exitnumber = data[idx].signpost.exitnumber
	local exitname = data[idx].signpost.exitname
	local strnumber, strname = L"", L""
	local preposition_name = true
	if exitnumber then
		strnumber = wstring.gsub(exitnumber.text,L"(%d+)",L"%1 ")
		strnumber = format_all_numbers2text(strnumber)
		preposition_name = nil
	end
	if exitname then
		strname=exitname.text
		voice_debug_log(L"TTS: signpost_exitname in: '"..strname..L"'", 3)
		strname = format_cases(format_mapinfo(strname, data[idx].signpost.country), "for_turns", preposition_name)
		voice_debug_log(L"TTS: signpost_exitname out: '"..strname..L"'", 3)
	end
	if exitnumber or exitname then
		return exit_preposition .. L" " .. strnumber .. (exitnumber and exitname and L"/" or L"") .. strname
	end
end

local function signpost_destination(data, idx)
	local dest = data[idx].signpost.destination
	if dest then
		local str=dest.text
		voice_debug_log(L"TTS: signpost_destination in: '"..str..L"'", 3)
		str = format_cases(format_mapinfo(str, data[idx].signpost.country), "for_turns", true)
		voice_debug_log(L"TTS: signpost_destination out: '"..str..L"'", 3)
		return str
	end
end

local function signpost_settlement(data, idx) 			--  в "напрвлении" где символы  '>>'
	local settlement = data[idx].signpost.settlement
	if settlement then
		local str=settlement.text
		voice_debug_log(L"TTS: signpost_settlement in: '"..str..L"'", 3)
		str = format_cases(format_mapinfo(str, data[idx].signpost.country), "for_turns")
		if not wstring.find(settlement.text,settlement_preposition) then
			str=settlement_preposition .. L" " .. str
		end
		voice_debug_log(L"TTS: signpost_settlement out: '"..str..L"'", 3)
		return str
	end
end

local function signpost_roadnumber(data, idx)    		--  название трассы M1 ... Mx
	local roadnumber = data[idx].signpost.roadnumber
	if roadnumber then
		local str=roadnumber.text
		voice_debug_log(L"TTS: signpost_roadnumber in: '"..str..L"'", 3)
		str = format_cases(format_roadnumber(str, data[idx].signpost.country), "for_turns", true)
		voice_debug_log(L"TTS: signpost_roadnumber out: '"..str..L"'", 3)
		return str
	end
end

local function road_name(data, idx, t_for_turns)
	local name = data[idx].road.name
	if name then
		local str=name.text
		voice_debug_log(L"TTS: road_name in: '"..str..L"'", 3)
		if t_for_turns == nil then t_for_turns = "for_turns" end
		str = format_cases(format_mapinfo(str, data[idx].road.country), t_for_turns, true)
		voice_debug_log(L"TTS: road_name out: '"..str..L"'", 3)
		return str
	end
end

local function road_number(data, idx, t_for_turns)
	local number = data[idx].road.number
	if number then
		local str=number.text
		voice_debug_log(L"TTS: road_number in: '"..str..L"'", 3)
		if t_for_turns == nil then t_for_turns = "for_turns" end
		str = format_cases(format_roadnumber(str, data[idx].road.country), t_for_turns, true)
		voice_debug_log(L"TTS: road_number out: '"..str..L"'", 3)
		return str
	end
end

function format_destname(data, idx)
	local t
	if data[idx].signpost then
		t = transform_chain({}, signpost_exit, 	data, idx)
		t = transform_chain(t,  signpost_roadnumber,data, idx)
		t = transform_chain(t,  signpost_destination,	data, idx)
		t = transform_chain(t,  signpost_settlement, 	data, idx)
	elseif data[idx].road then
		t = transform_chain({}, road_number, 	data, idx)
		t = transform_chain(t,  road_name, 	data, idx)
	end
	return table_concat(t, L"/")
end

function format_streetname(data, idx)
	local t = {}
	local out = road_number(data, idx, "for_directions")
	if out then table.insert(t, out) end
	out = road_name(data, idx, "for_directions")
	if out then table.insert(t, out) end
	return table_concat(t, L"/")
end

function format_sentence(str)
	for key, value in ipairs(replace_sentence) do
		str = wstring.gsub(str,value[1],value[2])
	end
	return str
end

local function format_replace_shield(str)
	for i=4190, 4200 do
		str = wstring.gsub(str, wstring.char(i),L"|")
	end
	str = wstring.gsub(str, wstring.char(4244),L"|")
	str = wstring.gsub(str, wstring.char(4255),L"|")
	str = wstring.gsub(str, L"|(.*)|",L"")
	return wstring.gsub(str, L"||",L"")
end  

function format_street_name(streetname)
	voice_debug_log(L"TTS: streetname from skin in: '"..streetname..L"'", 3)
	streetname = format_replace_shield(streetname)
	if wstring.sub(streetname, 1, 9) == L"for_turns" then
		streetname = format_cases(format_mapinfo(wstring.sub(streetname, 10)), "for_turns", true)
	else
		streetname = format_cases(format_mapinfo(streetname), "for_summary")
	end
	voice_debug_log(L"TTS: streetname from skin out: '"..streetname..L"'", 3)
	return streetname
end  

local transform_roadnumber_explode_eu_origvoice = transform_roadnumber_explode_eu
transform_roadnumber_explode_eu = function(str)
	local t = transform_roadnumber_explode_eu_origvoice(str)
	for k,_ in ipairs(t) do
		if t[k+1] and wstring.gsub(t[k], L" ", L"") == wstring.gsub(t[k+1], L" ", L"") then
			table.remove(t, k+1)
		end
	end
	return t
end

----------------------------------------------------------------------------------------------------
-----------------------------------|  R O U T E   S U M M A R Y  |----------------------------------
----------------------------------------------------------------------------------------------------

function route_summary_format_road_name(data)
        local str = data.text
	voice_debug_log(L"TTS: summary roadnumber in: '"..str..L"'", 3)
	str = format_roadnumber(str,"")
	voice_debug_log(L"TTS: summary roadnumber out: '"..str..L"'", 3)
	return str
end

function route_summary_format_street_name(data)
        local str = data.text
	voice_debug_log(L"TTS: summary streetname in: '"..str..L"'", 3)
	str = format_cases(format_mapinfo(str), "for_summary")
	voice_debug_log(L"TTS: summary streetname out: '"..str..L"'", 3)
	return str
end

function route_summary_format_bridge_tunnel(data)
        local str = data.text
	voice_debug_log(L"TTS: summary bridge_tunnel in: '"..str..L"'", 3)
	str = format_cases(format_mapinfo(str), "for_summary")
	voice_debug_log(L"TTS: summary bridge_tunnel out: '"..str..L"'", 3)
	return str
end

function route_summary_format_order(data)
        local str = data.text
	voice_debug_log(L"TTS: summary order in: '"..str..L"'", 3)
	str = format_cases(format_mapinfo(str), "for_summary")
	voice_debug_log(L"TTS: summary order out: '"..str..L"'", 3)
	return str
end

----------------------------------------------------------------------------------------------------
local function format_string2unicode(str)
	if not SysConfig:get("tts", "voice_log_to_unicode_chars", 1) then return str end
	local out, uni_code, repl_str
	out = L""
	for i = 1, #str do
		uni_code = wstring.byte(str, i)
		if uni_code >= 1025 and uni_code <= 1111 then repl_str = L"|"..wstring.sub(towstring(uni_code),2,4)
		else repl_str = wstring.sub(str,i,i) end
		out = out .. repl_str
	end
	return out
end
local voice_debug_log_origvoice = voice_debug_log
voice_debug_log = function(message, level)
	message = format_string2unicode(towstring(message))
	voice_debug_log_origvoice(message, level)
end
function smart_lower_case_get_codegroup(s)
	return s>=65 and s<=90 and 1 or (s>=97 and s<=122 and 2 or (s>=1040 and s<=1071 and 3 or (s>=1072 and s<=1103 and 4 or (s>=1025 and s<=1031 and 5 or (s>=1105 and s<=1111 and 6 or 0)))))
end
function smart_lower_case_inner1(s1, s3)
	local s2 = smart_lower_case_get_codegroup(wstring.byte(s1,1)) and (smart_lower_case_get_codegroup(wstring.byte(s3,1)) or wstring.byte(s3,1) == 32) and L"ь" or L"`"
	return s1..s2..s3
end
function smart_lower_case_inner2(s1, s3)
	local s2 = smart_lower_case_get_codegroup(wstring.byte(s1,1)) and (smart_lower_case_get_codegroup(wstring.byte(s3,1)) or wstring.byte(s3,1) == 32) and L"ъ" or L"'"
	return s1..s2..s3
end
function smart_lower_case_inner3(s1,s2,s3)
	local upper_shift = {0,-32,0,-32,0,-80}
	local lower_shift = {32,0,32,0,80,0}
	local shift, group1, group2, group3 = 0, smart_lower_case_get_codegroup(s1), smart_lower_case_get_codegroup(s2), smart_lower_case_get_codegroup(s3)
	if group2 then
		if not group1 and not group3 or group1 then shift = lower_shift[group2] end
		if not group1 and group3 then shift = upper_shift[group2] end
	end
	return wstring.char(s2+shift)
end
function smart_lower_case(str)
	str = L" " .. format_sentence(str) .. L" "
	str = wstring.gsub(str, L" [`'](%S+)[`'] ", L" %1 ")
	str = wstring.gsub(str, L"(%S)`(.*)", smart_lower_case_inner1)
	str = wstring.gsub(str, L"(%S)'(.*)",  smart_lower_case_inner2)
	local out = L" "
	for i = 2, #str-1 do
		out = out .. smart_lower_case_inner3(wstring.byte(str,i-1),wstring.byte(str,i),wstring.byte(str,i+1))
	end
	return out .. L" "
end
----------------------------------------------------------------------------------------------------
-----------------------------------------|  T R A F F I C  |----------------------------------------
----------------------------------------------------------------------------------------------------

-- 1. Zar az M0 uton, Martonvasar kozeleben. = in die Strasse Numer A1, in der Nahe von Martonvasar./ in der Nahe von der HaupStrasse Numer 33.
-- 2. Zar az M0 uton, Martonvasar es Velence kozt. = in die Strasse Numer A1, zwischen Martonvasar und Velence.
-- 3. Zar a Budai uton, a Budai ut Fiskalis ut keresztezodesben = in der/dem (lsd tabla) Budai ut, in der Kreuzung Budai ut und Fiskalis ut.
-- 4. Zar a Budai uton, Fiskalis ut es 8. ut kozott. = in der/dem Budai ut, zwischen Fiskalis ut und 8. ut.

function traffic_event_supported()
	return true
end
local function traffic_fromto_format_func(str)
	return wstring.gsub(str,L"^ ?(%S) ?%d+$",
		function (s)
			if smart_lower_case_get_codegroup(wstring.byte(s,1)) then return L"" else return s end
		end) == L"" and format_roadnumber or format_mapinfo
end
local function transform_traffic_fromto(fromto, str, roadname)
	local t = {}
	wstring.gsub(str, L"([^,]+),?", function(s) if s~=L"" then table.insert(t, transform_and_format(s, replace_for_turns_end)) end end)
	for k,_ in ipairs(t) do
		if roadname~=L"" and t[k+1] and (wstring.find(roadname, t[k+1]) or roadname==t[k+1]) then table.remove(t, k+1) end
	end
	if roadname~=L"" and (wstring.find(roadname, t[1]) or roadname==t[1]) then table.remove(t, 1) end
	if #t then
		str = t[1]
		if wstring.find(str, L"/") then
			t = {}
			wstring.gsub(str, L"([^/]+)/?", function(s) if s~=L"" then table.insert(t, transform_and_format(s, replace_for_turns_end)) end end)
			local str_format_function, str_is_number = nil, false
			for k,v in ipairs(t) do
				str_format_function = traffic_fromto_format_func(v)
				if str_format_function == format_roadnumber then str_is_number = true end
				t[k] = format_cases(str_format_function(v), "for_traffic_fromto")
			end
			if str_is_number then
				for k,_ in ipairs(t) do
					if t[k+1] and wstring.gsub(t[k], L" ", L"") == wstring.gsub(t[k+1], L" ", L"") then table.remove(t, k+1) end
				end
			end
			return fromto .. (#t > 1 and L" перекрестка " or L" ") .. table_concat(t, L" и ")
		else
			return fromto .. L" " .. format_cases(traffic_fromto_format_func(str)(str), "for_traffic_fromto")
		end
	end
	return L""
end
local function traffic_event_distance_get(dist)
	local unit_names = {"yards","meters","feet"}
	dist_table = distances[unit_names[MODEL.regional.units() + 1]]
	local _, _, f_dist = distance_formatter(dist)
	local dist_idx = search_distance_index(f_dist)
	local code_string
	if f_dist == dist_table[dist_idx] then code_string = dist_table[dist_idx + 1]
	else code_string = dist_table[search_distance_index(dist) + 1] end
	return decode_string(code_string, 1)
end
function traffic_event(DescKey, data)
	ASSERT(MODEL.regional.is_it_voice_localizable(DescKey), "Missing TrafficEvent dictionary.voice key:" .. DescKey)
	local traffic_on, traffic_roadname, traffic_from, traffic_to, voice_from, voice_to = L"", L"", L"", L"", L"", L""
	if data.roadnumber then
		traffic_on = format_cases(format_roadnumber(data.roadnumber.text), "for_traffic_on",true)
		voice_debug_log(L"TTS: traffic on roadnumber: '"..traffic_on..L"'", 3)
	elseif data.roadname then
		traffic_roadname = data.roadname.text
		voice_debug_log(L"TTS: traffic on roadname in: '"..traffic_roadname..L"'", 3)
		if wstring.find(traffic_roadname, L"/") then
			local t = {}
			wstring.gsub(traffic_roadname, L"([^/]+)/?", function(s) if s~=L"" then table.insert(t, transform_and_format(s, replace_for_turns_end)) end end)
			if #t then traffic_on = format_cases(format_mapinfo(t[1]), "for_traffic_on",true) end
			if #t>1 then traffic_on =  traffic_on .. L" в районе " .. format_cases(format_mapinfo(t[2]), "for_traffic_fromto") end
		else
			traffic_on = format_cases(format_mapinfo(traffic_roadname), "for_traffic_on",true)
		end
		voice_debug_log(L"TTS: traffic on roadname out: '"..traffic_on..L"'", 3)
	end
	if data.roadname then traffic_roadname = data.roadname.text end
	if traffic_on ~= L"" then traffic_on = L" " .. traffic_on end
	if data.from then
		voice_from = data.from.text
		voice_debug_log(L"TTS: traffic from in: '"..voice_from..L"'", 3)
		traffic_from = transform_traffic_fromto((data.to and L" , от" or L" , около"), voice_from, traffic_roadname)
		voice_debug_log(L"TTS: traffic from out: '"..traffic_from..L"'", 3)
	end
	if data.to then
		voice_to = data.to.text
		voice_debug_log(L"TTS: traffic to in: '"..voice_to..L"'", 3)
		traffic_to = transform_traffic_fromto(L" , до", voice_to, traffic_roadname)
		voice_debug_log(L"TTS: traffic to out: '"..traffic_to..L"'", 3)
	end
	local traffic_description, traffic_distance = translate_voice(DescKey), L""
	local traffic_description_on = traffic_events_description and MODEL.regional.current_language.lcid() == MODEL.regional.current_voice.lcid()
	if traffic_description_on then traffic_description_on = transform_pattern_match(towstring(DescKey), {L"ahead", L"blocked"}) end
	if (traffic_description_on or traffic_events_distance) and (data.roadname or data.from or data.to) then
		local current
		for i = 0, #MODEL.traffic.events.significant_events - 1 do
			current = MODEL.traffic.events.significant_events[i]
			if traffic_roadname == current.road_name() and voice_to == current.location_to() and voice_from == current.location_from() then
				if current.description() ~= L"" and traffic_description_on then traffic_description = format_tmc_description(current.description()) voice_debug_log(L"TTS: traffic description out: '"..traffic_description..L"'", 3) end
				if current.distance() and traffic_events_distance then traffic_distance = translated_voice_format(m_i18n_voice("After %s"), traffic_event_distance_get(current.distance())) ..  L" " end
				break
			end
			if i>30 then break end
		end
	end
	return traffic_distance .. traffic_description .. traffic_on .. traffic_from .. traffic_to
end

----------------------------------------------------------------------------------------------------
---------------------------------------------|  E T A  |--------------------------------------------
----------------------------------------------------------------------------------------------------
function format_all_numbers2text(str,spell)
	return wstring.gsub(str, L"(%d+)", function(s)
		local inner = L""
		if #s > 3 or wstring.find(s, L"^0") or spell then
			for i = 1, #s do inner = inner .. format_numbers2text(tonumber(wstring.sub(s, i, i))) end
		else inner = format_numbers2text(tonumber(s)) end
		return inner .. L" "
	end)
end  
function format_numbers2text(number)
	local index = {{39,9,43,49,33,53,37,4,13},
		{14,8,42,38,32,52,36,3,12},
		{25,5,40,47,30,50,34,1,10,14,26,7,41,48,31,51,35,2,11}}
	local str = towstring(number)
	if #str > 3 then return L" " .. str end
	if str == L"0" then return L" ноль" end
	local t = {}
	local out = L""
	for i = 1, #str do
		table.insert(t, tonumber(wstring.sub(str, i, i)))
	end
	for i = 1, (3 - #str)  do
		table.insert(t, 1, 0)
	end
	if (10 * t[2] + t[3]) < 20 then
		t[3] = 10 * t[2] + t[3]
		t[2] = 0
	end
	for i = 1, #t do
		if t[i] then
			out = out .. L" " .. distances.patterns[index[i][t[i]]]
		end
	end
	return out
end
function eta(time,waypoint)
	local head = waypoint and L"Прибытие в промежуточный пункт" or L"Прибытие"
	local hours, mins, tod = L"", L"", L""
	local hour = time.hour
	local min = time.min
	if hour == 0 then hour = 12 tod = L" - ночи" end
	if hour == 1 then hours = L" в час"
	else hours = L" в" .. format_numbers2text(hour) end
	if min == 0 then mins = L""
	elseif min < 10 then mins = L" ноль" .. format_numbers2text(min)
	else mins = format_numbers2text(min) end
	if min == 0 and tod == L"" then mins = L" ноль ноль" end
	return head..hours..mins..tod
end
over_speed_limit = function()
	local key = m_i18n_voice("The speed limit is %s!")
	if MODEL.regional.is_it_voice_localizable(key) then
		local speedunits = {"mph","km/h","mph"}
		local correct = SysConfig:get("tts", "correct_speed_unit", true) and MODEL.regional.is_it_voice_localizable(m_i18n_voice("km/h")) and MODEL.regional.is_it_voice_localizable(m_i18n_voice("mph"))
		local announce = SysConfig:get("tts", "announce_speed_unit", true)
		local limitphrasepart = (correct or not announce) and 2 or 0
		local limitphraseunit = correct and announce and (L" " .. translate_voice(speedunits[MODEL.regional.units() + 1])) or L""
		local limitphrase = MODEL.other.format_speed(MODEL.warning.driveralert.speed_limit(), MODEL.regional.units(), 1, limitphrasepart)
		if correct and announce then
			limitphrase = format_all_numbers2text(limitphrase)
		end
		return translated_voice_format(key, limitphrase .. limitphraseunit)
	end
end
wlocalized = {}
wlocalized.countries = {"_ukr"}
for _,v in pairs(wlocalized.countries) do
	wlocalized["loaded"..v] = false
end
if type(complete_POI_CAT_PRIO) == "function" then
	VOICE["complete_POI_CAT_PRIO"]()
	if not (fill_functions._PROC and condfun._PROC) then
		init_functions()
	end
end
